CON

  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000


 'MAX1270 Setup
  DIN   = 25                  ' Set Max1270 DataIn Pin
  DOUT  = 23                  ' Set Max1270 DataOut Pin
  CLK   = 27                  ' Set Max1270 SerialClock Pin
  CS    = 26                  ' Set Max1270 ChipSelect Pin
  'SSTRB = 24

  'Pin Config Out_TOR
  OTOR0 = 8
  OTOR1 = 9

OBJ
  max1270:      "Max1270"           'ADC interface
  ser :         "Extended_FDSerial"    'For debug and serial com

Var
  Long  CogAlarm                'Numro du cog qui gre l'alarme
  Long Alarm_stack[50]
  long val
PUB StartAlarm(ValAlarmHi,High_Pos,ValAlarmLo,Low_Pos,Latch_Alarm)


CogAlarm:=cognew(RunAlarm(ValAlarmHi,High_Pos,ValAlarmLo,Low_Pos,Latch_Alarm), @Alarm_stack[0])+1 

return CogAlarm

PUB RunAlarm(ValAlarmHi,High_Pos,ValAlarmLo,Low_Pos,Latch_Alarm)| signe '
ser.start(31, 30, 0, 9600)
'dira[OTOR1] ~~
repeat

   

  
    val:=max1270.get_millivolts(0, false, false) ' canal 0  / range : -10 +10
    HIGH(CS) 
    ser.dec(val)
    waitcnt(clkfreq*10 +cnt)
   { 
    if (val>0)
       signe := true
    else
       signe := false

    if(Latch_Alarm)'Alarme Latch
   
      if (val > ValAlarmHi )'and signe ==  High_Pos)
        HIGH(OTOR1)
             

        
              
      if (val < ValAlarmLo)' and signe == Low_Pos)  or( val > ValAlarmLo and signe <> Low_pos)
        HIGH(OTOR0)
    else 'Alarme momentane
    
      if (val > ValAlarmHi)' and signe ==  High_Pos) or( val < ValAlarmHi and signe <> High_pos)   
        HIGH(OTOR1)
      else
        LOW(OTOR1)
              
      if (val < ValAlarmLo)' and signe == Low_Pos) or( val > ValAlarmLo and signe <> Low_pos)
        HIGH(OTOR0)
      else
        LOW(OTOR0)
  else
    waitcnt(clkfreq/1000 + cnt) ' attends 1ms si le max 1270 est occup             
  waitcnt(clkfreq*10 + cnt) 'attend 0,5 secondes entre chaque mesure
}

PUB StopAlarm
  if CogAlarm
     ser.stop
     cogstop(CogAlarm~ -1 )


PUB HIGH(Pin)
    dira[Pin]~~
    outa[Pin]~~
         
PUB LOW(Pin)
    dira[Pin]~~
    outa[Pin]~
 